#include <stdlib.h>
#include <math.h>
#include <pthread.h>
#define max(__a__,__b__) (__a__ > __b__ ? __a__ : __b__)


typedef struct { 
double *t107;
double *t133;
int B_nrows;
double *t68;
double *t67;
double b;
double *y;
double *u1;
double *t77;
double *u2;
double *t78;
double *t49;
double *t58;
double *t136;
double *t70;
int __m105;
} GEMVER_0_msg_t;

void *GEMVER_body_0(void *mesg) {
int disp, __zr__,j,k;
GEMVER_0_msg_t *msg = (GEMVER_0_msg_t*)mesg;
double *t107 = msg->t107;
double *t133 = msg->t133;
int B_nrows = msg->B_nrows;
double *t68 = msg->t68;
double *t67 = msg->t67;
double b = msg->b;
double *y = msg->y;
double *u1 = msg->u1;
double *t77 = msg->t77;
double *u2 = msg->u2;
double *t78 = msg->t78;
double *t49 = msg->t49;
double *t58 = msg->t58;
double *t136 = msg->t136;
double *t70 = msg->t70;
int __m105 = msg->__m105;

for (__zr__ = 0; __zr__ < B_nrows; ++__zr__) t107[__zr__] = 0.0;
for (j=0; j<__m105; j+=1) {
// 4_2
double t95;
double *t88 = malloc(sizeof(double)*B_nrows);
double *t104 = t70 + j*B_nrows;
double *t135 = t136 + j*B_nrows;
double *t92 = t58 + j*B_nrows;
double *t83 = t49 + j*B_nrows;
for (k=0; k<B_nrows; k+=1) {
// 9_3
t88[k] = (u2[k]*t78[j]);
}
t95 = 0.0;
for (k=0; k<B_nrows; k+=1) {
// 4_3
t92[k] = (t88[k]+(t83[k]+(u1[k]*t77[j])));
t95 += (t135[k]*y[k]);
}
t68[j] = (t67[j]+(b*t95));
for (k=0; k<B_nrows; k+=1) {
// 19_3
t107[k] += (t104[k]*t133[j]);
}
free(t88);
}
return NULL;
}


void GEMVER
(int A_nrows, int A_ncols, double* A, double a, double b, int u1_nrows, double* u1, int u2_nrows, double* u2, int v1_nrows, double* v1, int v2_nrows, double* v2, int y_nrows, double* y, int z_nrows, double* z, int B_nrows, int B_ncols, double* B, int w_nrows, double* w, int x_nrows, double* x)
{
int disp, __zr__,i,ii;

int nparts__s105 = 6;
int __s105;
if (nparts__s105 > 1 && B_ncols > nparts__s105) {
__s105 = B_ncols/nparts__s105;
// this will fail if B_ncols%nparts__s105+__s105 > nparts__s105
// which primarily effects small sizes
if (B_ncols%nparts__s105)
++__s105;
}
else {
__s105 = B_ncols;
nparts__s105 = 1;
}

double *t73 = malloc(sizeof(double)*nparts__s105*B_nrows);
double *t44 = B;
double *t137 = B;
double *t21 = B;
double *t134 = x;
double *t23 = x;
double *t130 = t73;
GEMVER_0_msg_t *GEMVER_0 = malloc(sizeof(GEMVER_0_msg_t)*nparts__s105);
pthread_t *threads_0 = malloc(sizeof(pthread_t)*nparts__s105);
disp = 0;
for (i=0,ii=0; i<B_ncols; i+=__s105,ii+=1) {
// 4_1
int __m105 = i + __s105 > B_ncols ? B_ncols - i : __s105;
double *t70 = t44 + i*B_nrows;
double *t107 = t73 + ii*B_nrows;
double *t136 = t137 + i*B_nrows;
double *t133 = t134 + i;
double *t68 = x + i;
double *t58 = B + i*B_nrows;
double *t77 = v1 + i;
double *t49 = A + i*B_nrows;
double *t78 = v2 + i;
double *t67 = z + i;
GEMVER_0[disp].t107 = t107;
GEMVER_0[disp].t133 = t133;
GEMVER_0[disp].B_nrows = B_nrows;
GEMVER_0[disp].t68 = t68;
GEMVER_0[disp].t67 = t67;
GEMVER_0[disp].b = b;
GEMVER_0[disp].y = y;
GEMVER_0[disp].u1 = u1;
GEMVER_0[disp].t77 = t77;
GEMVER_0[disp].u2 = u2;
GEMVER_0[disp].t78 = t78;
GEMVER_0[disp].t49 = t49;
GEMVER_0[disp].t58 = t58;
GEMVER_0[disp].t136 = t136;
GEMVER_0[disp].t70 = t70;
GEMVER_0[disp].__m105 = __m105;

pthread_create(&threads_0[disp], NULL, GEMVER_body_0, (void *)(GEMVER_0+disp));
++disp;
}
for (disp = 0; disp < nparts__s105; ++disp) {
pthread_join(threads_0[disp],NULL);
}

free(threads_0);
free(GEMVER_0);
{
int __k;
for (i=0,ii=0; i<B_ncols; i+=__s105,ii+=1) {
// 4_1
int __m105 = i + __s105 > B_ncols ? B_ncols - i : __s105;
if ((ii == 0)) {
for (__k = 0; __k < B_nrows; __k+=1) {
t130[__k] = t73[ii*B_nrows+__k];
}
} else {
for (__k = 0; __k < B_nrows; __k+=1) {
t130[__k] += t73[ii*B_nrows+__k];
}
}
}
}

for (i=0; i<B_nrows; i+=1) {
// 20_1
w[i] = (a*t130[i]);
}
free(t73);
}
